Error trapping in parent/child scripts


 
Thread Tools Search this Thread
Top Forums Shell Programming and Scripting Error trapping in parent/child scripts
# 1  
Old 07-07-2007
Error trapping in parent/child scripts

Greets all. I'm using Slackware 12.0 with the bash shell. Calling my scripts with /bin/sh...

I'm building gnome-2.18.3 and I have all my build scripts ready and working but I'm calling them from a parent script which executes each child/build script in a certain order (for loop).

I have "set -e" in each child script but the parent keeps right on going if a child craps out. What's the quickest/easiest way to get the parent to exit on child failure?

Thanks everyone. Been looking high and low but can't seem to find the information I need and error trapping is pretty new to me.
# 2  
Old 07-07-2007
Either test the return code $? of the child or set -e in the parent.
# 3  
Old 07-07-2007
Sorry, forgot to mention that I do have "set -e" in my parent. Doesn't seem to be working. Sorry for my ignorance but could you possibly give an example of how to test the return code of a child?

Thanks for your help.
# 4  
Old 07-07-2007
Here's two ways, there are others.

Code:
childcommand || exit 1

Code:
childcommand
if [[ $? -ne 0 ]] ; then
   exit 1
fi

# 5  
Old 07-07-2007
I knew about the || exit 1 bit. Thanks for reminding me. However, it still doesn't work. I'm confounded.

http://jaguarlinux.com/pub/slackware....3/new/test.sh

That's my parent script. All of the new/*-*/*.build scripts are the children. 10:1 it's the way I'm implementing my commands. wrapping them in ( ) or something.

Sorry for the bother.
# 6  
Old 07-07-2007
Quote:
Originally Posted by reborg
Here's two ways, there are others.

Code:
childcommand || exit 1

Code:
childcommand
if [[ $? -ne 0 ]] ; then
   exit 1
fi

Uhh.. My previous reply is waiting on moderator aproval for some reason but I found the problem. I was wrapping my commands in parenthesis else I wouldn't return to "pwd" for the next package in line. Wrapping your commands like that somehow borks the error trapping. It's fixed now.

Thanks reborg for your help. I really appreciate it.
# 7  
Old 08-10-2007
Hi everyone,
while searching for our problem I found this thread, but we are still struggling. Help would be lovely.

We have:

#!/bin/sh

while read blabla
do
. childscript

rc=$?
if [[ $rc -gt 0 ]]
then
blabla
exit 4
fi


Childscript falls over, does 'exit 4' but $? is still empty....
Any ideas?

Thanks!!

Cheers,
Sandra W
Login or Register to Ask a Question

Previous Thread | Next Thread

10 More Discussions You Might Find Interesting

1. UNIX for Dummies Questions & Answers

parent and child directory

does anyone know how to check in an 'if' statement if a particular directory is a child directory of a particular directory? help ~ (2 Replies)
Discussion started by: ymc1g11
2 Replies

2. Shell Programming and Scripting

forking a child process and kill its parent to show that child process has init() as its parent

Hi everyone i am very new to linux , working on bash shell. I am trying to solve the given problem 1. Create a process and then create children using fork 2. Check the Status of the application for successful running. 3. Kill all the process(threads) except parent and first child... (2 Replies)
Discussion started by: vizz_k
2 Replies

3. Homework & Coursework Questions

Need help with deleting childīs parent and child subprocess

1. The problem statement, all variables and given/known data: I need to make an program that in a loop creates one parent and five children with fork(). The problem i'm trying to solve is how to delete the parent and child of the childīs process. 2. Relevant commands, code, scripts,... (0 Replies)
Discussion started by: WhiteFace
0 Replies

4. Programming

To share fd between parent and child

i used function fork(). so i made two process. parent process accepted socket fd and writing to shared memory. then now. how can child process share parent's socket fd? is this possible? Thanks in advance (1 Reply)
Discussion started by: andrew.paul
1 Replies

5. Shell Programming and Scripting

Strange SIGINT propagation between Parent/Child sh scripts

Good day, I am trying to add signal handling capabilities to some of my scripts. Unfortunately, I am having some difficulty with the manner in which signals are propagated between parent/child processes. Consider the following example: I have the following "parent" script: #!/usr/bin/sh... (5 Replies)
Discussion started by: danie.ludick
5 Replies

6. UNIX for Advanced & Expert Users

Child Killing Parent

Hi all, I am writing a script which calls other third party scripts that perform numerous actions. I have no control over these scripts. My problem is, one of these scripts seems to execute and do what it is meant to do, but my calling / parent script always exits at that point. I need to... (4 Replies)
Discussion started by: mark007
4 Replies

7. Shell Programming and Scripting

multiple child scripts running in backgroud, how to use grep on the parent?

Hi I have a shell script A which calls another 10 shell scripts which run in background. How do i make the parent script wait for the child scripts complete, or in other words, i must be able to do a grep of parent script to find out if the child scripts are still running. My Code: ... (5 Replies)
Discussion started by: albertashish
5 Replies

8. UNIX for Dummies Questions & Answers

kill parent and child

Hello all, I have gone through the search and looked at posting about idle users and killing processes. Here is my question I would like to kill an idle user ( which I can do) but how can I asure that all of his process is also killed whit out tracing his inital start PID. I have tried this on a... (4 Replies)
Discussion started by: larry
4 Replies

9. Filesystems, Disks and Memory

How hard can it be? ps child/parent

:( Since I'm fairly new to the scene and don't have much experience in shell programming, I decided to check out the net for a useful script or two. What I'm looking for is a script that would let me enter a PID and then show the process tree associated with it. So it would display the (grand-)... (2 Replies)
Discussion started by: velde046
2 Replies

10. UNIX for Dummies Questions & Answers

what are parent and child processes all about?

I don't follow what these are... this is what my text says... "When a process is started, a duplicate of that process is created. This new process is called the child and the process that created it is called the parent. The child process then replaces the copy for the code the parent... (1 Reply)
Discussion started by: xyyz
1 Replies
Login or Register to Ask a Question